apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: ssh
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: backups-{{ newznab_name }}
    backups.opsperator.io/service: backups-{{ newznab_name }}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ newznab_name }}
  name: {{ newznab_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ newznab_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ newznab_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ newznab_name }}
  strategy:
    recreateParams:
      timeoutSeconds: 1200
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ newznab_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ newznab_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ newznab_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: APACHE_DOMAIN
          value: newznab.{{ root_domain }}
        - name: APACHE_HTTP_PORT
          value: "8080"
        - name: ADMIN_PASS
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ newznab_name }}
        - name: ADMIN_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ newznab_name }}
        - name: API_KEY
          valueFrom:
            secretKeyRef:
              key: api-key
              name: {{ newznab_name }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: HTTP_PROXY
{% if proxy_host | default(False) %}
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
        - name: INFO_ADDRESS
          value: {{ newznab_info_address }}
        - name: MYSQL_NAME
{% if newznab_db_type in [ 'mariadb', 'mysql' ] %}
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ nnms_name }}
        - name: MYSQL_HOST
          value: {{ nnms_name }}
        - name: MYSQL_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ nnms_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ nnms_name }}
{% elif newznab_db_type == 'percona' %}
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ nnpc_name }}
        - name: MYSQL_HOST
          value: {{ nnpc_name }}-client
        - name: MYSQL_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ nnpc_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ nnpc_name }}
{% else %}
          value: ""
        - name: MYSQL_HOST
          value: ""
        - name: MYSQL_PASS
          value: ""
        - name: MYSQL_USER
          value: ""
{% endif %}
        - name: NNTP_HOST
          valueFrom:
            secretKeyRef:
              key: nntp-hostname
              name: {{ newznab_name }}
        - name: NNTP_PASS
          valueFrom:
            secretKeyRef:
              key: nntp-password
              name: {{ newznab_name }}
        - name: NNTP_PORT
          valueFrom:
            secretKeyRef:
              key: nntp-port
              name: {{ newznab_name }}
        - name: NNTP_TLS
          valueFrom:
            secretKeyRef:
              key: nntp-tls
              name: {{ newznab_name }}
        - name: NNTP_USER
          valueFrom:
            secretKeyRef:
              key: nntp-username
              name: {{ newznab_name }}
{% if do_ldap %}
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
{% else %}
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
{% endif %}
        - name: PHP_MAX_EXECUTION_TIME
          value: "{{ newznab_php_max_execution_time }}"
        - name: PHP_MEMORY_LIMIT
          value: {{ newznab_php_memory_limit }}
        - name: PUBLIC_PROTO
          value: https
        - name: SABNZBD_API_KEY
{% if do_sab %}
          valueFrom:
            secretKeyRef:
              key: api-key
              name: {{ sabnzbd_name }}
        - name: SABNZBD_HOST
          value: {{ sabnzbd_api_address | urlsplit('hostname') }}
        - name: SABNZBD_PROTO
          value: {{ sabnzbd_api_address | urlsplit('scheme') }}
        - name: SABNZBD_PORT
          value: "{{ sabnzbd_api_address | urlsplit('port') }}"
        - name: SABNZBDDL_HOST
          value: {{ sabnzbd_downloads_public | urlsplit('hostname') }}
        - name: SABNZBDDL_PROTO
          value: {{ sabnzbd_downloads_public | urlsplit('scheme') }}
{% else %}
          value: ""
        - name: SABNZBD_HOST
          value: ""
        - name: SABNZBD_PROTO
          value: ""
        - name: SABNZBD_PORT
          value: ""
        - name: SABNZBDDL_HOST
          value: ""
        - name: SABNZBDDL_PROTO
          value: ""
{% endif %}
        - name: SITE_NAME
          value: {{ newznab_site_name }}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='newznab'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='newznab'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 39
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 30
          timeoutSeconds: 8
        name: newznab
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            path: /
            port: 8080
          initialDelaySeconds: 15
          periodSeconds: 5
          timeoutSeconds: 4
        resources:
          limits:
            cpu: "{{ newznab_cpu_limit }}"
            memory: "{{ newznab_memory_limit }}"
          requests:
            cpu: "{{ newznab_cpu_request }}"
            memory: "{{ newznab_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 39
          httpGet:
            path: /
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 30
          timeoutSeconds: 8
{% endif %}
        volumeMounts:
{% if (do_ldap or sabnzbd_api_address | default(False)) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/apache2/sites-enabled
          name: run
          subPath: apache
{% if do_ldap %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /usr/local/share/ca-certificates
          name: run
          subPath: ca-certificates
        - mountPath: /var/www/html/config
          name: data
          subPath: config
        - mountPath: /var/www/html/www/covers
          name: data
          subPath: covers
        - mountPath: /var/www/html/www/lib/smarty/templates_c
          name: run
          subPath: smarty
        - mountPath: /var/www/html/nzbfiles
          name: data
          subPath: nzbfiles
      - args:
        - /job.sh
        command:
        - /usr/bin/dumb-init
        env:
        - name: JOB_INTERVAL
          value: "{{ newznab_job_interval }}"
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: HTTP_PROXY
{% if proxy_host | default(False) %}
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
        - name: PHP_MEMORY_LIMIT
          value: {{ newznab_job_php_memory_limit }}
{% if do_triggers == False or (opsimages | json_query("[?name=='newznab'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='newznab'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: job
        resources:
          limits:
            cpu: "{{ newznab_job_cpu_limit }}"
            memory: "{{ newznab_job_memory_limit }}"
          requests:
            cpu: "{{ newznab_job_cpu_request }}"
            memory: "{{ newznab_job_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /var/www/html/config
          name: data
          subPath: config
        - mountPath: /var/www/html/www/covers
          name: data
          subPath: covers
        - mountPath: /var/www/html/nzbfiles
          name: data
          subPath: nzbfiles
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8080/server-status
        - --telemetry.address=:9113
{% if do_triggers == False or (opsimages | json_query("[?name=='httpexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 39
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 30
          periodSeconds: 30
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 39
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 30
          periodSeconds: 30
          timeoutSeconds: 3
{% endif %}
{% endif %}
{% if do_backups %}
{% if do_triggers == False or (opsimages | json_query("[?name=='sshd'].short"))[0] == False %}
      - image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
{% else %}
      - imagePullPolicy: {{ pull_policy }}
{% endif %}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 2222
          timeoutSeconds: 3
        name: sshd
        ports:
        - containerPort: 2222
        resources:
          limits:
            cpu: {{ sshd_cpu_limit }}
            memory: {{ sshd_memory_limit }}
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /home/backup
          name: run
          subPath: bkphome
        - mountPath: /var/backup
          name: run
          subPath: bkpvar
        - mountPath: /.ssh/id_rsa.pub
          name: ssh
          subPath: id_rsa.pub
        - mountPath: /backups
          name: data
{% endif %}
{% if do_exporters %}
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - stats
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if (rwx_storage | default(False) and rwx_needs_fsgroup | default(False)) or (rwx_storage is not defined and rwo_needs_fsgroup | default(False)) %}
      securityContext:
{% if rwx_storage | default(False) and rwx_needs_fsgroup | default(False) %}
        fsGroup: {{ rwx_needs_fsgroup }}
{% elif rwx_storage is not defined and rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ newznab_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: data
        persistentVolumeClaim:
          claimName: {{ newznab_name }}
{% if do_ldap %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or sabnzbd_api_address | default(False)) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
{% if do_ldap %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if sabnzbd_api_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: sab-ca.crt
{% if sabnzbd_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
      - emptyDir: {}
        name: run
{% if do_backups %}
      - name: ssh
        secret:
          secretName: backups-{{ newznab_name }}
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='newznab'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - newznab
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='newznab'].short"))[0] }}
        namespace: {{ buildns }}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - job
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='newznab'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='httpexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='httpexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_backups and (opsimages | json_query("[?name=='sshd'].short"))[0] %}
  - imageChangeParams:
      automatic: true
      containerNames:
      - sshd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sshd'].short"))[0] }}
        namespace: {{ buildns }}
    type: ImageChange
{% endif %}
  - type: ConfigChange
{% endif %}
